/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.readGraph.getPredicates;

import java.util.Collection;
import java.util.UUID;

import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.testing.annotation.Fails;
import org.simantics.db.testing.base.WriteReadTest;
import org.simantics.db.tests.common.Writes;

@Fails
public class GetPredicatesTest3 extends WriteReadTest {

    private Resource type;
    private Resource string1;
    private Resource string2;
    private Resource string3;

	@Override
	protected void write(WriteGraph graph) throws DatabaseException {

        type = graph.newResource();
        graph.claim(type, L0.Inherits, L0.Entity);
        
        string1 = Writes.string(graph, UUID.randomUUID().toString());
        string2 = Writes.string(graph, UUID.randomUUID().toString());
        string3 = Writes.string(graph, UUID.randomUUID().toString());

        graph.claim(type, L0.HasName, string1);
        graph.claim(type, L0.HasName, string2);
        graph.claim(type, L0.HasName, string3);

	}
	@Override
    protected void read(ReadGraph graph) throws DatabaseException {
        Collection<Resource> result = graph.getPredicates(type);
        assertNotNull("Null not allowed", result);
        int size = result.size();
        assertTrue("Wrong number of predicates: " + size,
        		(size == 7));
        //assertTrue(Tests.contains(predicates));
        //assertTrue(Tests.contains(predicates, L0.SupertypeOf, named2));
    }
	/*
	@Override
	protected void read(ReadGraph graph) throws DatabaseException {
		Collection<Statement> statements = graph.getStatements(type, L0.HasName);
		assertTrue("foo", (graph.isInstanceOf(L0.HasName, L0.FunctionalRelation)));
        assertTrue("Wrong number of statements: " + statements.size(), 
        		(statements.size() == 1));
		
	}
*/
}
