/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.readGraph.getPredicates;

import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.testing.base.WriteReadTest;

public class PredicatePropertiesTest extends WriteReadTest {
    
    
    @Override
    protected void read(ReadGraph graph) throws DatabaseException {
    	Resource[] predicates = {L0.Asserts, L0.ConsistsOf, L0.DependsOn, L0.HasDataType,
        		L0.HasLabel, L0.HasName, L0.HasPredicate, L0.HasValueType, L0.Inherits,
        		L0.InstanceOf, L0.IsRelatedTo, L0.IsWeaklyRelatedTo, L0.SubrelationOf};
    	if (DEBUG)
    	    System.out.println("Is Functional:");
    	for (int i=0; i<predicates.length; i++) {
        	Resource predicate = predicates[i];
        	boolean isFunctional = graph.isInstanceOf(predicate, L0.FunctionalRelation);
        	if (DEBUG)
        	    System.out.println(i + " " + isFunctional);
    	}
    	if (DEBUG)
    	    System.out.println("SubRelationOf:");
    	for (int i=0; i<predicates.length; i++) {
    		Resource predicate1 = predicates[i];
        	for (int j=0; j<predicates.length; j++) {
        		Resource predicate2 = predicates[j];
        		boolean isSubRelationOf = graph.isSubrelationOf(predicate1, predicate2);
        		if (DEBUG)
        		    System.out.println(i + "," + j + " : " + isSubRelationOf);
        	}
    	}
    }
}
