/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.readGraph.getStatements;

import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.exception.ManyObjectsForFunctionalRelationException;
import org.simantics.db.testing.annotation.Fails;
import org.simantics.db.testing.base.WriteReadTest;
import org.simantics.db.tests.api.readGraph.common.Ontologies;

@Fails
public class GetStatementsWithAssertionsTest3 extends WriteReadTest {

	private Resource type;
    private Resource string1;
    private Resource string2;
    private Resource string3;
    @Override
    protected void write(WriteGraph graph) throws DatabaseException {
    	written=Ontologies.typeMultipleFunctionalAssertions(L0, graph);
    }
    
    @Override
    protected void read(ReadGraph graph) throws DatabaseException {
    	try {
    		graph.getStatements(type, L0.HasName);
    	} catch (ManyObjectsForFunctionalRelationException e) {
    		return;
    	} catch (Exception e) {
    		fail("Wrong exception was thrown " + e.getClass().getCanonicalName());
    	}
		fail("Should throw");
    } 
}
