/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.readGraph.getStatements;

import java.util.Collection;

import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.Statement;
import org.simantics.db.WriteGraph;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.testing.annotation.Fails;
import org.simantics.db.testing.base.WriteReadTest;
import org.simantics.db.tests.api.readGraph.common.Ontologies;

@Fails
public class GetStatementsWithAssertionsTest6 extends WriteReadTest {

    private Resource type;
    private Resource named1;
    private Resource named2;
    private Resource string1;
    
    @Override
    protected void write(WriteGraph graph) throws DatabaseException {
    	written=Ontologies.typeFunctionalAndNonFunctionalAssertions(L0, graph);
       
    }
    
    @Override
    protected void read(ReadGraph graph) throws DatabaseException {
        Collection<Statement> results = graph.getStatements(type, L0.ConsistsOf);
        assertTrue("Null returned", (results!=null));
        assertTrue("Wrong number of results returned: " + results.size(), (results.size() == 2));
        
    }
    
}
