/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.readGraph.getSuperRelations;

import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.exception.ServiceException;
import org.simantics.db.testing.annotation.Fails;
import org.simantics.db.testing.base.WriteReadTest;

@Fails
public class GetSuperrelationsTest3 extends WriteReadTest {
	
	private Resource relation1;
	private Resource relation2;

	@Override
    protected void write(WriteGraph graph) throws DatabaseException {
    	
        relation1 = graph.newResource();
        relation2 = graph.newResource();

        graph.claim(relation1, L0.InstanceOf, L0.Relation);

        graph.claim(relation2, L0.SubrelationOf, relation1);
        graph.claim(relation1, L0.SubrelationOf, relation2);


	}
	@Override
    protected void read(ReadGraph graph) throws DatabaseException {
    	try {
    		graph.getSuperrelations(relation2);
    	} catch (ServiceException e) {
    		return;
    	} catch (Exception e) {
    		fail("Wrong exception was thrown");
    	}
    	fail("Should throw");
    }
}
