/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.request.exception;

import org.junit.Test;
import org.simantics.db.ReadGraph;
import org.simantics.db.Session;
import org.simantics.db.common.procedure.adapter.ListenerAdapter;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.request.Read;
import org.simantics.db.testing.annotation.Fails;
import org.simantics.db.testing.base.ExistingDatabaseTest;

public class ExceptionInEqualsTest extends ExistingDatabaseTest {
	
	boolean exceptionOk = false;
	
	@Fails
	@Test(timeout = 5000)
	public void testWriteException() throws Exception {
		
		Session session = getSession();
		
		try {

			session.syncRequest(new Read<Object>() {

				@Override
				public Object perform(ReadGraph graph) throws DatabaseException {
					System.out.println("perform");
					return null;
				}            
				
				@Override
				public boolean equals(Object obj) {
					System.out.println("equals");
					throw new NullPointerException();
				}

			}, new ListenerAdapter<Object>() {
				@Override
				public void exception(Throwable e) {
					System.out.println("Got exception " + e.getMessage());
					if(e instanceof NullPointerException)
						exceptionOk = true;
				}
				@Override
				public boolean isDisposed() {
					return false;
				}
			});
		
		} catch (Throwable e) {

			System.out.println("Got exception " + e.getMessage());
			
			return;
			
		}
		
		if(!exceptionOk)
			fail("Write transaction did not throw an exception.");
		
	}

}
