/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.support.clusterControl;

import org.junit.Test;
import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;
import org.simantics.db.common.primitiverequest.HasStatementSubject;
import org.simantics.db.common.request.WriteResultRequest;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.service.ClusterControl;
import org.simantics.db.testing.base.ExistingDatabaseTest;
import org.simantics.db.testing.common.WriteQuery;

public class WriteAfterClusterCollectTest3 extends ExistingDatabaseTest {
	
	@Test
	public void test() throws Exception{

		final Resource resource = getSession().syncRequest(new WriteResultRequest<Resource>() {
		    @Override
		    public Resource perform(WriteGraph g) throws DatabaseException {
		    	return g.newResource();
		    }
		});
		
		checkException();

		getSession().syncRequest(new HasStatementSubject(resource));
		
		ClusterControl support = getSession().getService(ClusterControl.class);
		support.collectClusters(Integer.MAX_VALUE);
		
		checkException();
		
        getSession().syncRequest(new WriteQuery(this) {
        	
            @Override
            public void run(WriteGraph g) throws Throwable {

            	g.newResource();
                
            }
            
        });
        
        checkException();
		
	}

}
