/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.performance.read;

import java.util.UUID;

import org.simantics.db.Resource;
import org.simantics.db.Session;
import org.simantics.db.VirtualGraph;
import org.simantics.db.service.VirtualGraphSupport;
import org.simantics.db.testing.base.ExistingDatabaseTest;

public class ReadHierarchicalNamesFromVirtualGraph extends ExistingDatabaseTest {
	
	final private static String name = "name";
	int[] sizes = { 244, 64, 64 };
	
	public void test() throws Exception {
		
		Session session = getSession();

		VirtualGraph graph = session.getService(VirtualGraphSupport.class).getMemoryPersistent(UUID.randomUUID().toString());
		
		// First build the test data
		long start = System.nanoTime();
		Resource root = session.syncRequest(HierarchicalNames.writeOnly2(name, sizes, graph));
		long duration = System.nanoTime() - start;
		System.out.println("write = " + 1e-9*duration);

		start = System.nanoTime();
		session.syncRequest(HierarchicalNames.readAsync(root));
		duration = System.nanoTime() - start;
		System.out.println("cold start = " + 1e-9*duration);
		
	}

}
